Subject: Re: bug#12799: 24.3.50; `scroll-conservatively', I-search and `C-g'

From: Eli Zaretskii <[email-masked]>
Date: Sat, 30 Jan 2016 22:13:47 +0200

> Date: Sat, 30 Jan 2016 20:49:02 +0100
> Cc: [email-masked]
> 
> On 2012-11-04, at 19:07, Dani Moncayo <[email-masked]> wrote:
> 
> > Recipe from "emacs -nw -Q" (the "-nw" part is not strictly needed, but
> > it is cleaner for showing the problem):
> >
> > 1. Visit the attached file.
> > 2. Adjust the vertical space (empty lines) between "first line" and
> > "last visible line" until the latter becomes indeed the last visible
> > line in the window.
> > 3. Go to the start of the buffer: M-<
> > 4. Advance one line: C-n
> > 5. C-s 1
> > 6. C-g
> >
> > I observe that after step #5 the window is scrolled (OK), and that
> > scrolling is cancelled after step #6 (OK - like it should be).
> >
> > But if I set `scroll-conservatively' to 1 and repeat the experiment
> > (from step #3), I observe that the vertical scrolling made in step #5
> > is not cancelled in step #6.  IMO it should be cancelled, because
> > "C-g" should leave the view (not just the point) where it was before
> > the Isearch.
> 
> Hi everyone,
> 
> I can confirm that this behavior is still present in GNU Emacs
> 25.1.50.1.  I am not 100% sure, however, whether this is really
> a bug.

No, it isn't a bug, but the intended behavior: contrary to the OP's
expectations C-g is _not_ supposed to cancel the scroll, it is
supposed to return point to where the search started.  And setting
scroll-conservatively to 1 means that if point is 1 line above or
below the window, Emacs should scroll the window only by 1 line in
order to bring point into view.  Which is what Emacs does in this
case.

So I'm closing the bug.  I apologize for not noticing it when it was
originally reported.

Thanks.